package com.tasamu.figu_score.txt2csv;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;

/**
 * テキスト化されたプロトコルを清書する。
 */

public class Txt2Csv {
    String flnm = null;

    String wk_str = "                                         " +
            "                                         " +
            "                                         " +
            "                                         " +
            "                                              ";

    /**
     * 処理実行
     * @param args ファイル名
     */
    public static void main(String[] args) {

        try {
            if (args.length == 0) {
                throw new Exception("args count wrong");
            }

            for( int i = 0 ; i < args.length ; i++) {
                System.out.println("### " + args[i] + " ###");
                Txt2Csv fto = new Txt2Csv(args[i]);
                fto.exec();
            }

        } catch (Exception e) {
            System.err.println("Usage: java Txt2Csv files ...");
        }
    }

    /**
     * 実行
     * @throws Exception 例外
     */
    public void exec() throws Exception {
        String line="";;
        try {
            FileReader in = new FileReader(flnm);
            BufferedReader br = new BufferedReader(in);

            Score score = new Score();

            ArrayList<Ele> eless = null;
            ArrayList<Pcs> pcss = null;

            long competition_id = -1;
            long player_id = -1;

            ArrayList<String> lines = new ArrayList<String>();
            while ((line = br.readLine()) != null) {
                lines.add(line);
            }
            lines.add(null);

            String cname = lines.get(0);
            cname = cname.trim();

            String cat_seg = lines.get(1);
            cat_seg = cat_seg.substring(0, 40).trim();
            cat_seg = cat_seg.replaceAll(" +", " ");
            cat_seg = cat_seg.replaceFirst(" ", ",");
            System.out.println(cname + "," + cat_seg);

            /* if (!noIns) {
                // competition_id = com.insert(conn);
            } */

            int i = 0;
            while ((line = lines.get(i++)) != null) {
                if( line.indexOf("Score") < line.indexOf("Score (factored)")    ) {
                    i++;
                    score = new Score();
                    eless = new ArrayList<Ele>();
                    pcss = new ArrayList<Pcs>();

                    line = lines.get(i++);
                    line = line.replaceAll(" +", " ");
                    line = line.replaceAll("^ ", "");


                    setStr1st(line, score);
                    /* if (!noIns)
                        player_id = player.insert(conn); */
                }

                // エレメント
                if( line.indexOf("Elements") > -1 && line.indexOf("Value") > -1 && line.indexOf("Panel") > -1  ) {
                    line = lines.get(i++);
                    for( ;  ;  line = lines.get(i++) ) {
                        boolean mbrk = false;
                        // 終わり？
                        if( lines.get(i).indexOf("Judges Total Element Score") > -1 ) {
                            line = line.replaceAll(" +", " ");
                            line = line.replaceAll("^ ", "");
                            // 終わりの次はbvとtes
                            setBVByLine( score, line);
                            // i++;
                            break;
                        }

                        // 複数行？
                        // 行番号がない。または、数字が少ないと複数行開始とみなす
                        if( line.trim().length() == 0 )
                            continue;
                        if(  line.charAt(6) == ' '  ||  line.charAt(3) == ' '
                                || ( ( (line.replaceAll("[0-9]", "").length()+20) > line.length() )) ||
                                line.charAt(line.length() - 3 ) != '.') {

                            // 連続終わり、またはエレメント終わりまで
                            // 連続終わり
                            char[] chary = wk_str.toCharArray();
                            // 次の行で絡むがカブってない
                            while( true) {
                                if( line.trim().length() > 0 &&  line.trim().charAt(0) != ' ') // 要素番号行
                                set( chary, line);
                                // 次の行で同カラム更新ならブレーク
                                boolean lbrk = false;
                                if( check( chary, lines.get(i)) )
                                    lbrk = true;
                                // エレメント終わり？
                                if( lines.get(i+1).indexOf("Judges Total Element Score") > -1 ||
                                        //                      Program Components                   Factor
                                        ( lines.get(i+2).indexOf("Program Components ") > -1 && lines.get(i+2).indexOf("  Factor") > -1) ) {
                                    // 終わりの次はbvとtes
                                    setBVByLine( score,  lines.get(i));
                                    mbrk = true;
                                    break;
                                }
                                if( lbrk ) break;
                                line = lines.get(i++);
                            } // 連続行の連結

                            line = new String(chary);
                        }
                        line = line.replaceAll(" +", " ");
                        line = line.replaceAll("^ ", "");
                        line = line.replaceAll(" x", "x");
                        if( line.length() == 0 )
                            continue;
                        Ele ele = setElesByLine(line);
                        // ele.setDetail(conn);
                        eless.add(ele);
                        if( mbrk ) break;
                    }

                }
                // pcs
                if( line.indexOf("Program Components") > -1 ) {

                    for( int k = 0 ; k < 5 ; k++ ) {
                        line = lines.get(i++);
                        line = line.replaceAll(" +", " ");
                        line = line.replaceAll("^ ", "");
                        Pcs pcs = setPcsByLine(line);
                        pcss.add(pcs);
                    }

                    score.setCompetitionId(competition_id);
                    score.setPlayerId(player_id);

                    long score_id = -1;
                    System.out.println(score.toCSV());
                    /* if (!noIns)
                        score_id = score.insert(conn); */

                    for (Ele el : eless) {
                        el.setScoreId(score_id);
                        System.out.println(el.toCSV());
                        /* if (!noIns)
                            el.insert(conn); */
                    }

                    int p = 0;
                    for (Pcs pc : pcss) {
                        pc.setScoreId(score_id);
                        System.out.println(pc.toCSV(p++));
                        /* if (!noIns)
                            pc.insert(conn); */
                    }
                    System.out.println();
                    pcss = null;
                }

            }
            // conn.commit();

            br.close();
            in.close();
        } catch (Exception e) {
            System.err.println(line);
            e.printStackTrace();
            throw e;
        }
    }

    /**
     * 重複する部分文字列がないか検査する
     * @param chAry 追加後、文字配列
     * @param line 追加する文字列
     * @return 重複の場合 true、重複なしならfalse
     */
    private boolean check( char[] chAry, String line ) {
        boolean ret = false;

        for( int i = 0 ; i < line.length() && i < chAry.length ; i++ ) {
            if( line.charAt(i) != ' ' && chAry[i] != ' ' ) {
                return true;
            }
        }

        return ret;
    }

    /**
     * 行を重ねる
     * @param chAry 追加後、文字配列
     * @param line 追加する文字列
     * @return 重ねた結果
     */
    private char[] set( char[] chAry, String line) {
        for( int k = 0 ; k < line.length() && k < chAry.length ; k++ ) {
            if( line.charAt(k) != ' '  ) {
                chAry[k] = line.charAt(k);
            }
        }
        return chAry;
    }

    /**
     * 行よりPCSを生成
     * @param line 行データ
     * @return PCS
     * @throws Exception 例外
     */
    private Pcs setPcsByLine(String line) throws Exception {

        // Skating Skills 1.00 9.00 8.75 9.50 9.25 9.50 9.50 9.25 8.75 9.00 9.18
        line = line.replaceAll("[A-Z]", "");
        line = line.replaceAll("[a-z]", "");
        line = line.replaceAll("/", "");
        line = line.trim();

        int pp = line.indexOf(":");
        if( pp > -1 ) {
            line = line.substring(0, pp);
        }

        Pcs pcs = new Pcs();
        int st = line.indexOf(" ", 1);
        int en = st;
        ArrayList<String> wk = new ArrayList<String>();
        try {
        for (; en > -1;) {
            en = line.indexOf(" ", st + 1);
            String vls;
            if (en < 0)
                vls = line.substring(st + 1);
            else
                vls = line.substring(st + 1, en);
            st = en;
            if ("-".equals(vls.trim()))
                continue;
            if( vls.length() < 1)
                continue;
            vls = vls.replaceAll("\\.", "");
            wk.add(vls.trim());
        }
        int[] juges = new int[wk.size() - 1];
        int i = 0;
        for (; i < juges.length; i++) {
            String jj =  wk.get(i).replaceAll("--","");
            juges[i] = Integer.parseInt((String) (jj));
        }
        String vl = wk.get(i).replaceAll("--","");
        int value = Integer.parseInt((String) (vl));
        if( value < 0 ) value = -value;
        pcs.setValue(value);
        pcs.setValues(juges);

        } catch ( Exception e ) {
            System.err.println(line);
            e.printStackTrace();
            throw e;
        }
        return pcs;
    }

    /**
     * 行よりエレメントを生成
    * @param line 行
     * @return エレメント
     */
    private Ele setElesByLine(String line) {
        line = line.trim();
        Ele eles = new Ele();
        try {
            int st = line.indexOf(" ");
            String seq_str = line.substring(0, st);
            int seq = Integer.parseInt(seq_str.trim());

            line = line.replaceAll("---------", "0 0 0 0 0 0 0 0 0 ");

            int en = line.indexOf(" ", st + 2);
            String name = line.substring(st + 1, en);
            name = name.trim();
            String level_s = name.substring(name.length() - 1);
            int level = -1;
            try {
                level = Integer.parseInt(level_s);
            } catch (Exception e) {

            }

            st = en;
            en = line.indexOf(" ", st + 1);
            String bv_str = line.substring(st + 1, en);
            if (bv_str.equals("e")) {
                eles.setIllegal(true);
                st = en;
                en = line.indexOf(" ", st + 1);
                bv_str = line.substring(st + 1, en);
            }
            if (bv_str.indexOf("<") > -1) {
                st = en;
                en = line.indexOf(" ", st + 1);
                bv_str = line.substring(st + 1, en);
            }
            if (bv_str.indexOf("x") > -1) {
                eles.setLate(true);
                bv_str = bv_str.replaceAll("x", "");
            }

            // 1.0 なら　1.00
            int dPos = bv_str.indexOf(".");
            dPos = bv_str.length() - dPos;
            if( dPos == 2)
                bv_str += "0";


            bv_str = bv_str.replaceAll("\\.", "");
            int base_value = -1;
            try {
                base_value = Integer.parseInt(bv_str);
            } catch (Exception e) {
            }

            st = en;
            en = line.indexOf(" ", st + 1);
            String goe_str = line.substring(st + 1, en);
            if (goe_str.indexOf("x") > -1) {
                st = en;
                en = line.indexOf(" ", st + 1);
                goe_str = line.substring(st + 1, en);
                eles.setLate(true);
            }
            goe_str = goe_str.replaceAll("\\.", "");
            int goe = Integer.parseInt(goe_str);

            ArrayList wk_goes = new ArrayList();
            for (st = en; en > 0;) {
                en = line.indexOf(" ", st + 1);
                if (en > -1)
                    goe_str = line.substring(st + 1, en);
                else
                    goe_str = line.substring(st + 1);
                if (goe_str.indexOf("x") > -1) {
                    eles.setLate(true);
                    continue;
                }
                if (en < 0 || goe_str.indexOf(".") > -1) {
                    goe_str = goe_str.replaceAll("\\.", "");
                    goe_str = goe_str.replaceAll("--", "");
                    int scp = Integer.parseInt(goe_str);

                    int[] goes = new int[wk_goes.size()];
                    for (int i = 0; i < goes.length; i++) {
                        goes[i] = -999;
                        try {
                            goes[i] = Integer
                                    .parseInt((String) (wk_goes.get(i)));
                        } catch (Exception e) {
                        }
                    }

                    eles.setSeq(seq);
                    eles.setName(name);
                    eles.setBaseValue(base_value);
                    if( scp < 0 ) scp = -scp;
                    eles.setScore(scp);
                    eles.setGoe(goe);
                    eles.setGoes(goes);
                    if (level > 0)
                        eles.setLevel(new Integer(level));
                    break;
                }
                st = en;
                if ("-".equals(goe_str.trim()))
                    continue;
                wk_goes.add(goe_str.trim());
            }

        } catch (Exception e) {
            System.err.println(line);
            e.printStackTrace();
        }
        return eles;
    }

    /**
     * 行よりbase valuseを生成しセット
     * @param score スコア
     * @param line 行
     */
    private void setBVByLine( Score score, String line) {
        String wk = line.replaceAll(" +", " ");
        wk = wk.replaceAll("^ ", "");
        int pos = wk.indexOf(' ');
        if( pos > -1 )
            wk = wk.substring(0, pos);
        wk = wk.trim();
        int sj = 1;
        if( wk.length() == ( wk.indexOf('.') +2 ) ) {
            sj = 10;
        }
        wk = wk.replaceAll("\\.", "");

        int bv = Integer.parseInt(wk);
        bv = bv * sj;
        score.setBaseValueTtl(bv);
    }

    /**
     * 最初のデータを生成
     * @param line 行
     * @param score スコア
     */
    private void setStr1st(String line, Score score) {
    // 1 Mao ASADA JPN 22 78.66  42.81 35.85 0.00

        String strSeq = null;

        int pos = line.indexOf(".");
        line = line.substring(0, pos + 3 ) + " " + line.substring(pos + 3);

        // 先頭文字から順位とる
        line = line.trim();
        pos = line.indexOf(' ');
        int nml = pos;
        String str = line.substring(0, pos);
        int rank = Integer.parseInt(str.replaceAll("\\.", ""));

        // 末尾から減点とる
        pos = line.lastIndexOf(' ');
        str = line.substring(pos + 1);
        int ded = Integer.parseInt(str.replaceAll("\\.", ""));

        // PCS
        int pos2 = line.lastIndexOf(' ', pos - 1);
        str = line.substring(pos2 + 1, pos);
        int pcs = Integer.parseInt(str.replaceAll("\\.", ""));

        // TES
        pos = line.lastIndexOf('.', pos2 - 1);
        pos2 = line.lastIndexOf('.', pos - 1);
        str = line.substring(pos2 + 3, pos + 3);
        str = str.trim();
        int tes = Integer.parseInt(str.replaceAll("\\.", ""));

        // TSS
        pos = line.lastIndexOf(' ', pos2 - 1);
        str = line.substring(pos + 1, pos2+3);
        int tss = Integer.parseInt(str.replaceAll("\\.", ""));

        // seq
        pos2 = line.lastIndexOf(' ', pos - 1);
        strSeq = line.substring(pos2 + 1, pos);
        int seq = Integer.parseInt(strSeq.replaceAll("\\.", ""));

        // 3L
        //pos2 = pos; //line.lastIndexOf(' ', pos - 1);
        pos = line.lastIndexOf(" ", pos2 - 1);
        str = line.substring(pos + 1, pos2);
        String country = str;

        String name = line.substring(nml + 1, pos);

        score.setRank(rank);
        score.setStartNumber(seq);
        score.setDeductions(ded);
        score.setPcs(pcs);
        score.setTes(tes);
        score.setTss(tss);
        score.setName(name);
        score.setCountry(country);
    }


    /**
     * 引数のテキストを処理
     * @param flnm ファイル名
     */
    public Txt2Csv(String flnm) {
        super();

        this.flnm = flnm;

    }

}
